Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 738810 - sys-devel/patch-2.7.6-r4 tests fail with "1: eval: Bad substitution" with app-shells/dash
Summary: sys-devel/patch-2.7.6-r4 tests fail with "1: eval: Bad substitution" with app...
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Gentoo's Team for Core System packages
URL: https://git.savannah.gnu.org/cgit/pat...
Whiteboard:
Keywords: PATCH, TESTFAILURE, UPSTREAM
Depends on:
Blocks: nonbash
  Show dependency tree
 
Reported: 2020-08-24 11:39 UTC by Paolo Pedroni
Modified: 2021-04-30 19:01 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
patch-2.7.6-r4:20200824-112308.log.gz (patch-2.7.6-r4:20200824-112308.log.gz,23.29 KB, application/gzip)
2020-08-24 11:39 UTC, Paolo Pedroni
Details
patch-2.7.6-fix-test-suite-further.patch (patch-2.7.6-fix-test-suite-further.patch,959 bytes, patch)
2021-01-03 07:33 UTC, Kerin Millar
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Paolo Pedroni 2020-08-24 11:39:12 UTC
Created attachment 656422 [details]
patch-2.7.6-r4:20200824-112308.log.gz

>>> Test phase: sys-devel/patch-2.7.6-r4
[...]
FAIL: asymmetric-hunks
FAIL: backup-prefix-suffix
FAIL: bad-filenames
FAIL: bad-usage
FAIL: concat-git-diff
FAIL: copy-rename
XFAIL: context-format
FAIL: corrupt-patch
FAIL: corrupt-reject-files
FAIL: create-delete
FAIL: create-directory
FAIL: criss-cross
FAIL: crlf-handling
XFAIL: dash-o-append
FAIL: deep-directories
FAIL: empty-files
FAIL: false-match
FAIL: fifo
FAIL: file-create-modes
FAIL: file-modes
FAIL: filename-choice
FAIL: git-cleanup
FAIL: git-binary-diff
FAIL: git-error
FAIL: garbage
FAIL: inname
FAIL: global-reject-files
FAIL: line-numbers
FAIL: merge
FAIL: mangled-numbers-abort
FAIL: mixed-patch-types
FAIL: munged-context-format
FAIL: need-filename
FAIL: no-mode-change-git-diff
FAIL: no-newline-triggers-assert
FAIL: preserve-c-function-names
FAIL: preserve-mode-and-timestamp
FAIL: quoted-filenames
FAIL: reject-format
FAIL: read-only-files
FAIL: remember-backup-files
FAIL: remember-reject-files
FAIL: remove-directories
FAIL: symlinks
FAIL: unmodified-files
============================================================================
Testsuite summary for GNU patch 2.7.6
============================================================================
# TOTAL: 45
# PASS:  0
# SKIP:  0
# XFAIL: 2
# FAIL:  43
# XPASS: 0
# ERROR: 0
============================================================================
See tests/test-suite.log
Please report to bug-patch@gnu.org
============================================================================
make[4]: *** [Makefile:1413: test-suite.log] Error 1
make[4]: Leaving directory '/var/tmp/portage/sys-devel/patch-2.7.6-r4/work/patch-2.7.6/tests'
make[3]: *** [Makefile:1521: check-TESTS] Error 2
make[3]: Leaving directory '/var/tmp/portage/sys-devel/patch-2.7.6-r4/work/patch-2.7.6/tests'
make[2]: *** [Makefile:1899: check-am] Error 2
make[2]: Leaving directory '/var/tmp/portage/sys-devel/patch-2.7.6-r4/work/patch-2.7.6/tests'
make[1]: *** [Makefile:1325: check-recursive] Error 1
make[1]: Leaving directory '/var/tmp/portage/sys-devel/patch-2.7.6-r4/work/patch-2.7.6'
make: *** [Makefile:1615: check] Error 2

# cat /var/tmp/portage/sys-devel/patch-2.7.6-r4/work/patch-2.7.6/tests/test-suite.log
===========================================
   GNU patch 2.7.6: tests/test-suite.log
===========================================

# TOTAL: 45
# PASS:  0
# SKIP:  0
# XFAIL: 2
# FAIL:  43
# XPASS: 0
# ERROR: 0

.. contents:: :depth: 2

FAIL: asymmetric-hunks
======================

./asymmetric-hunks: 1: eval: Bad substitution
FAIL asymmetric-hunks (exit status: 2)

FAIL: backup-prefix-suffix
==========================

./backup-prefix-suffix: 1: eval: Bad substitution
FAIL backup-prefix-suffix (exit status: 2)

FAIL: bad-filenames
===================

./bad-filenames: 1: eval: Bad substitution
FAIL bad-filenames (exit status: 2)

FAIL: bad-usage
===============

./bad-usage: 1: eval: Bad substitution
FAIL bad-usage (exit status: 2)

FAIL: concat-git-diff
=====================

./concat-git-diff: 1: eval: Bad substitution
FAIL concat-git-diff (exit status: 2)

XFAIL: context-format
=====================

./context-format: 1: eval: Bad substitution
XFAIL context-format (exit status: 2)

FAIL: copy-rename
=================

./copy-rename: 1: eval: Bad substitution
FAIL copy-rename (exit status: 2)

FAIL: corrupt-patch
===================

./corrupt-patch: 1: eval: Bad substitution
FAIL corrupt-patch (exit status: 2)

FAIL: corrupt-reject-files
==========================

./corrupt-reject-files: 1: eval: Bad substitution
FAIL corrupt-reject-files (exit status: 2)

FAIL: create-delete
===================

./create-delete: 1: eval: Bad substitution
FAIL create-delete (exit status: 2)

FAIL: create-directory
======================

./create-directory: 1: eval: Bad substitution
FAIL create-directory (exit status: 2)

FAIL: criss-cross
=================

./criss-cross: 1: eval: Bad substitution
FAIL criss-cross (exit status: 2)

FAIL: crlf-handling
===================

./crlf-handling: 1: eval: Bad substitution
FAIL crlf-handling (exit status: 2)

XFAIL: dash-o-append
====================

./dash-o-append: 1: eval: Bad substitution
XFAIL dash-o-append (exit status: 2)

FAIL: deep-directories
======================

./deep-directories: 1: eval: Bad substitution
FAIL deep-directories (exit status: 2)

FAIL: empty-files
=================

./empty-files: 1: eval: Bad substitution
FAIL empty-files (exit status: 2)

FAIL: false-match
=================

./false-match: 1: eval: Bad substitution
FAIL false-match (exit status: 2)

FAIL: fifo
==========

./fifo: 1: eval: Bad substitution
FAIL fifo (exit status: 2)

FAIL: file-create-modes
=======================

./file-create-modes: 1: eval: Bad substitution
FAIL file-create-modes (exit status: 2)

FAIL: file-modes
================

./file-modes: 1: eval: Bad substitution
FAIL file-modes (exit status: 2)

FAIL: filename-choice
=====================

./filename-choice: 1: eval: Bad substitution
FAIL filename-choice (exit status: 2)

FAIL: git-binary-diff
=====================

./git-binary-diff: 1: eval: Bad substitution
FAIL git-binary-diff (exit status: 2)

FAIL: git-cleanup
=================

./git-cleanup: 1: eval: Bad substitution
FAIL git-cleanup (exit status: 2)

FAIL: git-error
===============

./git-error: 1: eval: Bad substitution
FAIL git-error (exit status: 2)

FAIL: garbage
=============

./garbage: 1: eval: Bad substitution
FAIL garbage (exit status: 2)

FAIL: global-reject-files
=========================

./global-reject-files: 1: eval: Bad substitution
FAIL global-reject-files (exit status: 2)

FAIL: inname
============

./inname: 1: eval: Bad substitution
FAIL inname (exit status: 2)

FAIL: line-numbers
==================

./line-numbers: 1: eval: Bad substitution
FAIL line-numbers (exit status: 2)

FAIL: merge
===========

./merge: 1: eval: Bad substitution
FAIL merge (exit status: 2)

FAIL: mangled-numbers-abort
===========================

./mangled-numbers-abort: 1: eval: Bad substitution
FAIL mangled-numbers-abort (exit status: 2)

FAIL: mixed-patch-types
=======================

./mixed-patch-types: 1: eval: Bad substitution
FAIL mixed-patch-types (exit status: 2)

FAIL: munged-context-format
===========================

./munged-context-format: 1: eval: Bad substitution
FAIL munged-context-format (exit status: 2)

FAIL: need-filename
===================

./need-filename: 1: eval: Bad substitution
FAIL need-filename (exit status: 2)

FAIL: no-mode-change-git-diff
=============================

./no-mode-change-git-diff: 1: eval: Bad substitution
FAIL no-mode-change-git-diff (exit status: 2)

FAIL: no-newline-triggers-assert
================================

./no-newline-triggers-assert: 1: eval: Bad substitution
FAIL no-newline-triggers-assert (exit status: 2)

FAIL: preserve-c-function-names
===============================

./preserve-c-function-names: 1: eval: Bad substitution
FAIL preserve-c-function-names (exit status: 2)

FAIL: preserve-mode-and-timestamp
=================================

./preserve-mode-and-timestamp: 1: eval: Bad substitution
FAIL preserve-mode-and-timestamp (exit status: 2)

FAIL: quoted-filenames
======================

./quoted-filenames: 1: eval: Bad substitution
FAIL quoted-filenames (exit status: 2)

FAIL: read-only-files
=====================

./read-only-files: 1: eval: Bad substitution
FAIL read-only-files (exit status: 2)

FAIL: reject-format
===================

./reject-format: 1: eval: Bad substitution
FAIL reject-format (exit status: 2)

FAIL: remember-backup-files
===========================

./remember-backup-files: 1: eval: Bad substitution
FAIL remember-backup-files (exit status: 2)

FAIL: remember-reject-files
===========================

./remember-reject-files: 1: eval: Bad substitution
FAIL remember-reject-files (exit status: 2)

FAIL: remove-directories
========================

./remove-directories: 1: eval: Bad substitution
FAIL remove-directories (exit status: 2)

FAIL: symlinks
==============

./symlinks: 1: eval: Bad substitution
FAIL symlinks (exit status: 2)

FAIL: unmodified-files
======================

./unmodified-files: 1: eval: Bad substitution
FAIL unmodified-files (exit status: 2)

# emerge --info =sys-devel/patch-2.7.6-r4
Portage 2.3.103 (python 3.7.8-final-0, default/linux/amd64/17.1/desktop/plasma/systemd, gcc-9.3.0, glibc-2.31-r6, 5.7.16-gentoo x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-5.7.16-gentoo-x86_64-Intel-R-_Core-TM-_i5-8400_CPU_@_2.80GHz-with-gentoo-2.6
KiB Mem:    16123188 total,  11453636 free
KiB Swap:   16777212 total,  16670204 free
Timestamp of repository gentoo: Wed, 19 Aug 2020 14:00:01 +0000
Head commit of repository gentoo: c87110aac367a9d3725fbd234e086bb53b2c5d66
sh bash 5.0_p17
ld GNU gold (Gentoo 2.33.1 p2 2.33.1) 1.16
ccache version 3.7.10 [disabled]
app-shells/bash:          5.0_p17::gentoo
dev-java/java-config:     2.3.1::gentoo
dev-lang/perl:            5.30.3::gentoo
dev-lang/python:          2.7.18-r1::gentoo, 3.7.8-r2::gentoo, 3.8.5::gentoo
dev-util/ccache:          3.7.10::gentoo
dev-util/cmake:           3.16.5::gentoo
sys-apps/baselayout:      2.6-r1::gentoo
sys-apps/sandbox:         2.18::gentoo
sys-devel/autoconf:       2.13-r1::gentoo, 2.69-r4::gentoo
sys-devel/automake:       1.16.1-r1::gentoo
sys-devel/binutils:       2.33.1-r1::gentoo
sys-devel/gcc:            9.3.0-r1::gentoo
sys-devel/gcc-config:     2.3.1::gentoo
sys-devel/libtool:        2.4.6-r6::gentoo
sys-devel/make:           4.2.1-r4::gentoo
sys-kernel/linux-headers: 5.4-r1::gentoo (virtual/os-headers)
sys-libs/glibc:           2.31-r6::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000
    sync-rsync-verify-max-age: 24
    sync-rsync-extra-opts: 
    sync-rsync-verify-metamanifest: yes
    sync-rsync-verify-jobs: 1

x-portage
    location: /usr/local/portage
    masters: gentoo
    priority: 0

ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -frecord-gcc-switches -march=skylake -mabm -flto=6"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/gnupg/qualified.txt"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe -frecord-gcc-switches -march=skylake -mabm -flto=6"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--keep-going y --with-bdeps y"
ENV_UNSET="DBUS_SESSION_BUS_ADDRESS DISPLAY GOBIN GOPATH PERL5LIB PERL5OPT PERLPREFIX PERL_CORE PERL_MB_OPT PERL_MM_OPT XAUTHORITY XDG_CACHE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_RUNTIME_DIR"
FCFLAGS="-O2 -pipe -frecord-gcc-switches -march=skylake -mabm -flto=6"
FEATURES="assume-digests binpkg-docompress binpkg-dostrip binpkg-logs cgroup compress-build-logs config-protect-if-modified distlocks ebuild-locks ipc-sandbox merge-sync multilib-strict network-sandbox news parallel-fetch pid-sandbox preserve-libs protect-owned qa-unresolved-soname-deps sandbox sfperms sign split-elog split-log strict strict-keepdir test unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe -frecord-gcc-switches -march=skylake -mabm -flto=6"
GENTOO_MIRRORS="http://mirrors.evowise.com/gentoo/ https://mirrors.evowise.com/gentoo/ http://mirror.eu.oneandone.net/linux/distributions/gentoo/gentoo/ http://mirror.netcologne.de/gentoo/"
LANG="it_IT.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,--hash-style=gnu -Wl,--sort-common -flto=6"
LINGUAS="it it_IT"
MAKEOPTS="-j7 -l6"
PKGDIR="/var/cache/binpkgs"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac aalib acl acpi activities adns alsa amd64 ao audiofile bash-completion bluetooth branding brotli bzip2 cairo caps cdda cddb cdparanoia cdr cli crypt css cups curl dbus declarative dga djvu dri dts dvd dvdr emboss encode exif expat fbcon ffmpeg fftw flac fontconfig foomaticdb fortran ftp gd gdbm geoip gif gimp gmp gnutls gphoto2 gpm graphviz gtk handbook iconv icu idn imagemagick imlib introspection ipv6 java javascript jbig jemalloc jpeg jpeg2k kde kipi kwallet lame lcms libass libglvnd libnotify libsamplerate libtirpc lm_sensors lua lzma lzo mad mmap mng mp3 mp4 mpeg mplayer multilib musicbrainz ncurses nls nptl nsplugin offensive ogg openal opengl openmp pam pango pcre pdf phonon plasma png policykit postscript ppds pulseaudio qml qt5 rdesktop readline recode samba sctp sdl seccomp sndfile sockets speex spell split-usr sqlite ssl startup-notification svg symlink syslog systemd sysvipc taglib telemetry test theora threads tidy tiff truetype udev udisks unicode upower usb vaapi vala vim-syntax vnc vorbis wavpack wayland widgets win32codecs wmf wxwidgets x264 xattr xcb xine xml xpm xscreensaver xv xvid yahoo zlib zstd" ABI_X86="64" ADA_TARGET="gnat_2018" ALSA_CARDS="hda-intel virmidi" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="karbon sheets words" CAMERAS="kodak ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx avx2 f16c fma3 mmx mmxext pclmul popcnt rdrand sse sse2 sse3 sse4_1 sse4_2 ssse3" CURL_SSL="gnutls" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock greis isync itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf skytraq superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="libinput" KERNEL="linux" L10N="it en" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="nlpsolver wiki-publisher" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php7-2 php7-3" POSTGRES_TARGETS="postgres10 postgres11" PYTHON_SINGLE_TARGET="python3_7" PYTHON_TARGETS="python3_7" RUBY_TARGETS="ruby25" USERLAND="GNU" VIDEO_CARDS="intel i965" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BINHOST, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

=================================================================
                        Package Settings
=================================================================

sys-devel/patch-2.7.6-r4::gentoo was built with the following:
USE="test xattr -static" ABI_X86="(64)"

# emerge -1pqv =sys-devel/patch-2.7.6-r4
[ebuild   R   ] sys-devel/patch-2.7.6-r4  USE="test xattr -static"
Comment 1 Kerin Millar 2021-01-03 07:33:28 UTC
Created attachment 680791 [details, diff]
patch-2.7.6-fix-test-suite-further.patch

Here is a patch that is supplemental to the existing "fix-test-suite" patch. It is also eligible for upstream but the instance here is intended to apply cleanly for the current ebuild.
Comment 3 Sam James archtester gentoo-dev Security 2021-04-29 01:11:42 UTC
ping. can someone apply the patch?
Comment 4 Mike Gilbert gentoo-dev 2021-04-29 21:15:06 UTC
Is this really important enough to warrant a backport?
Comment 5 Mike Gilbert gentoo-dev 2021-04-29 21:16:15 UTC
Anyway, if the patch works, feel free to commit it.
Comment 6 Sam James archtester gentoo-dev Security 2021-04-29 21:57:58 UTC
(In reply to Mike Gilbert from comment #4)
> Is this really important enough to warrant a backport?

This is one of those things I'd prefer not to bother anybody about but would still like fixed, so it's hard to get the balance right. I don't really like nagging about this sort of thing either. Thanks for putting up with it.

Point taken, although my view is that if we have a patch, we may as well use it - especially because it just makes life easier if we have to stable a revision before the next release (I use dash most of the time when doing arch testing now).

(In reply to Mike Gilbert from comment #5)
> Anyway, if the patch works, feel free to commit it.

Thanks!
Comment 7 Kerin Millar 2021-04-29 21:59:19 UTC
It was important enough for (In reply to Mike Gilbert from comment #4)
> Is this really important enough to warrant a backport?

Apparently, it was important enough for commit ff5c047 to have occurred. By what metric would it be less important now than it was then?
Comment 8 Thomas Deutschmann gentoo-dev Security 2021-04-29 22:15:05 UTC
(In reply to Kerin Millar from comment #7)
> Apparently, it was important enough for commit ff5c047 to have occurred. By
> what metric would it be less important now than it was then?

Previous commit fixed a problem you will experience when running Gentoo out of the box. To experience the reported bug you would have to switch default shell...

Anyway, I'll take care of it.
Comment 9 Kerin Millar 2021-04-29 22:16:25 UTC
(In reply to Thomas Deutschmann from comment #8)
> Previous commit fixed a problem you will experience when running Gentoo out
> of the box. To experience the reported bug you would have to switch default
> shell...

That's a compelling answer.

> Anyway, I'll take care of it.

Thanks.
Comment 10 Larry the Git Cow gentoo-dev 2021-04-29 22:21:11 UTC
The bug has been closed via the following commit(s):

https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=c02ca61191198aacf2bd51c4d5a7b53b1cbb5ab9

commit c02ca61191198aacf2bd51c4d5a7b53b1cbb5ab9
Author:     Thomas Deutschmann <whissi@gentoo.org>
AuthorDate: 2021-04-29 22:20:43 +0000
Commit:     Thomas Deutschmann <whissi@gentoo.org>
CommitDate: 2021-04-29 22:21:08 +0000

    sys-devel/patch: fix test suite when using dash
    
    Closes: https://bugs.gentoo.org/738810
    Package-Manager: Portage-3.0.18, Repoman-3.0.3
    Signed-off-by: Thomas Deutschmann <whissi@gentoo.org>

 .../patch/files/patch-2.7.6-fix-test-suite.patch      | 19 ++++++++++++++++---
 1 file changed, 16 insertions(+), 3 deletions(-)
Comment 11 Mike Gilbert gentoo-dev 2021-04-30 17:23:33 UTC
Just to further explain my reaction: We are talking about an issue that only affects the test suite, and only when the system shell is dash. These 2 things together will affect a miniscule number of users, and there are a couple of very simple/obvious workarounds.

Anyway, it was sort of a grumpy response, so apologies to all.
Comment 12 Kerin Millar 2021-04-30 19:01:08 UTC
(In reply to Mike Gilbert from comment #11)
> Just to further explain my reaction: We are talking about an issue that only
> affects the test suite, and only when the system shell is dash. These 2
> things together will affect a miniscule number of users, and there are a
> couple of very simple/obvious workarounds.
> 
> Anyway, it was sort of a grumpy response, so apologies to all.

Not to worry. It was a pertinent question, the motivation for which was rendered clear to me by reading Thomas' comment. All's well that ends well, as the saying goes.